{
  Six Axis Linear interpolative motion control 


  Ken Bash
  BioEmbedded Research LLC.

  



}

Obj
      text    :  "tv_wtext"        
   
      move    :  "6axpasm V.95"
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  _stack        = 50

 
var
   

'long firstdata ' to index flags to 4  delete later, just a test
'long pcount   ' a value to show the asm pgm is working

long flags           ' flags for assembly function calls.   Loaded and checked first in assy function

long pcount 

                       ' desired position values
long xto              
long yto
long zto
long wto              
long rto
long tto
           
long xpos              ' cartesian xyz positions
long ypos
long zpos
long wpos              ' rotation axis
long rpos
long tpos


long rampsteps
long ramprate
long startspeed
long maxspeed


long xstps
long ystps
long zstps   ' ( only used for verification.   Can be deleted later )

long lastf

long ttpos[20]



pub main                   | xt,yt,zt,wt,rt,tt, flgs, tptr

   settpos
   
   text.start(12)   
                    ' set some random goto values 
   xt := 5
   yt := 22
   zt := 345678        
   wt := 44
   rt := 123456  
   tt := 777777              
   flgs := 0
   tptr := 0
   
        text.out(0)
        text.str(string("  6 axis interpolative stepper demo"))
        text.out($0a)
        text.out($0a)
        text.out($0d)
          
        text.str(string("   moving to first position now. ")) 
        
   

     
      move.setats( 0,0,0,5000000,0,0 ) ' just to show you can set the axis start positions other than zero. 
      move.start
      move.setspeed(1) ' for demo purpose, let the speed value be as fast as possible


      ' the following movement demo changes some position values and resets bit 0 of the
      ' motion control flag.  
                                                
        
 repeat
           
             
               pcount ++   
                xt := xt + 45
           
             move.go2(xt,yt,zt ,1,rt,tt)
             
            
             
               move.setflag($1)
             repeat while flgs <> 2   
                 flgs := move.getflags
            
           
         
          
            tt := ttpos[tptr]
         '    tt++
             tptr ++

             if tptr > 20
              tptr := 0 
            
            
            yt := yt +3
            rt := rt * -1

           
           if tt > 160
          
               if rt < 1
                   move.setspeed( 300 )
                 text.str(string(" fast push  T axis controlled"))
          
               else
                  move.setspeed(1)
                 text.str(string(" slow pull  T axis controlled"))      
          
           else
            move.setspeed(1)  ' this gives a differential speed demo. Fast push, slow pull

                                    ' note on the demo it looks like it's opposite because the
                                    ' displayed values are the last AT positions, not the positions that
                                    ' are being driven to.
                                    
                                    
                 

          zt := zt -5001

            flgs := move.getflags
       repeat while flgs < 2   
             flgs := move.getflags
            
        
       showall
   
  
pub settpos        | ndx

ndx := 0

 repeat 20
   ttpos[ndx] := ndx * 10
   ndx ++
   
      
pub showat

  text.out($0d) 
   text.dec(xpos)

pub showall                   | dflag


flags := move.getflags


text.out(0)


text.dec(pcount)
text.out($0d)


text.hex(flags,6)
text.out($09)
text.str(string(" flags"))     
text.out($0d)  

xpos := move.getxp   
text.out ($0d) 
text.dec (xpos)
text.out($09)
text.str(string(" X position"))   

ypos := move.getyp   
text.out ($0d)
text.dec (ypos)
text.out($09)
text.str(string(" Y "))     
 

zpos := move.getzp   
 text.out ($0d)
text.dec (zpos) 
text.out($09)
text.str(string(" Z "))     
   

wpos := move.getwp      
 text.out ($0d)
text.dec (wpos)
text.out($09)
text.str(string(" W "))     
  text.out ($0d)

 rpos := move.getrp      
text.dec(rpos)
text.out($09)
text.str(string(" R "))     
 
 
text.out ($0d)

tpos := move.gettp      
text.dec (tpos)
text.out($09)
text.str(string(" T "))     
 


'waitcnt(cnt + 1000000)
text.out ($0d)
 {
lastf :=move.getlast      
text.hex (lastf, 8)
text.out ($0d)
text.dec (lastf) 
waitcnt(cnt + 1000000)  
 }
 



pub portest        | p



p := 19

  dira[12] := 1
  dira[13] := 1
  dira[14] := 1
  
    dira[p] := 1


          repeat
            outa[12] := 1
            outa[13] := 1
            outa[14] := 1
          
           outa[p] := 1
 

       
            waitcnt(cnt+10000000)
            outa[12] := 0
            outa[13] := 0
            outa[14] := 0
            
            outa[p] := 1
  
            waitcnt(cnt+10000000)
                